# Compilation on Linux Debian
## Get chordV 


~~~bash
sudo apt-get install git 
git clone https://git.code.sf.net/p/chordv/code chordv-code
~~~

## Podofo compilation from sources

### Install dependancies on Ubuntu 1.04

~~~bash
    sudo apt-get install -y subversion cmake
    sudo apt-get install -y libz-dev libfreetype6-dev libfontconfig1-dev libjpeg-dev libssl-dev libcrypto++9v5-dev libtiff5-dev
    sudo apt-get install -y libcppunit-dev liblua50-dev libidn11-dev lua5.1-dev
~~~

### Install dependancies on Ubuntu 16.04 LTS

~~~bash
    sudo apt-get install -y subversion cmake
    sudo apt-get install -y libz-dev libfreetype6-dev libfontconfig1-dev libjpeg-dev libssl-dev libcrypto++-dev libtiff5-dev
    sudo apt-get install -y libcppunit-dev liblua50-dev libidn11-dev lua5.1-dev
    sudo apt-get install qtmultimedia5-dev libqt5multimediawidgets5 libqt5multimedia5-plugins libqt5multimedia5
~~~

### Compile documentation 

~~~bash 
sudo apt-get install pandoc highlight texlive-xetex
cd Docs
make 
~~~

### Install /usr/share/chordV dir

~~~bash
sudo ./install
~~~

### Librairy Podofo compilation

~~~
    cd Libraries/src
    ./build.sh
~~~

### Chord V compilation 

~~~bash
cd ../..
qmake
make
~~~

## Install Doxygen

~~~bash
sudo apt install doxygen doxygen-gui graphviz
~~~



# Compilation on Windows 10


### Before to compile libpodofo

### Install Qt Framework

Download 5.4 + for Windows release from Qt-project.org

Libpodofo is used in chordV and we have to compile it.
We will use the c++ compiler from Qt to compile it

- Install visual C++ and choose visual Studio with  2015  C++
- Be shure Qt creator can compile a small example program




### Before compiling

- We will compile all libraries in shared mode (.DLL) and not in static mode (.LIB)
- You have to install git from https://git-scm.com/downloads to donwload chordV
- To launch cmake you have to go in command console from MSVC ( where you type dir to see the content of dir)
- To launch tar zxvf or other you have open git console (where your type ls to see content of dir) and you can tar also
- In command.com x86  console launch
- Toc check a dll is c86 type

~~~bash
dumpbin /headers file.dll
~~~

### Compile zlib

From zlib.net download zlib-1.2.11

In msdos console type
~~~
mkdir build.clang && cd build.clang
cmake .. -G Ninja -DCMAKE_INSTALL_PREFIX=c:\Users\gille\Developpe -DCMAKE_BUILD_TYPE=Release
cmake --build . --config Release --target install
~~~

### Compile libjpeg


Download from  http://www.ijg.org/files

Download libjpeg-9d.zip

There is no support for CMake build so I will use them from “Steffen Ohrendorf project libjpeg-cmake”: https://github.com/stohrendorf/libjpeg-cmake

In msdos console type

~~~bash
cd jpeg-9d
curl https://raw.githubusercontent.com/stohrendorf/libjpeg-cmake/master/CMakeLists.txt -O
~~~

~~~bash
curl https://raw.githubusercontent.com/stohrendorf/libjpeg-cmake/master/jconfig.h.in -O
mkdir build.clang && cd build.clang
cmake .. -G Ninja -DCMAKE_INSTALL_PREFIX=c:\Users\gille\Developpement -DCMAKE_BUILD_TYPE=Release
cmake --build . --config Release --target install
~~~

The libjpeg.dll library will be located is in the Developpement/bin directory

## Compile freetype2

- Download from https://sourceforge.net/project/freetype the freetype2 project

~~~bash
mkdir build.clang && cd build.clang
cmake .. -G Ninja -DCMAKE_INSTALL_PREFIX=c:\Users\gille\Developpement -DCMAKE_BUILD_TYPE=Release -D BUILD_SHARED_LIBS:BOOL=true
cmake --build . --config Release --target install
~~~


## Compile png

- Download from http://www.libpng.org/pub/png/libpng.html

~~~bash
cd libpng-1.6.37
mkdir build.clang && cd build.clang
cmake .. -G Ninja -DCMAKE_INSTALL_PREFIX=c:\Users\gille\Developpement -DCMAKE_BUILD_TYPE=Release
cmake --build . --config Release --target install
~~~

## Compile tiff

- Download from http://download.osgeo.org/libtiff/

~~~bash
cd iff-4.1.0
mkdir build.clang && cd build.clang
cmake .. -G Ninja -DCMAKE_INSTALL_PREFIX=c:\Users\gille\Developpement -DCMAKE_BUILD_TYPE=Release
cmake --build . --config Release --target install
~~~


## Compile libpodofo

- Download at http://podofo.sourceforge.net/download.html

Apply the patch

~~~
--- test/TokenizerTest/CMakeLists.txt.old	2018-07-20 18:26:02.921494293 +0200
+++ test/TokenizerTest/CMakeLists.txt	2018-07-20 18:34:53.727136443 +0200
@@ -2,10 +2,3 @@
 TARGET_LINK_LIBRARIES(TokenizerTest ${PODOFO_LIB} ${PODOFO_LIB_DEPENDS})
 SET_TARGET_PROPERTIES(TokenizerTest PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
 ADD_DEPENDENCIES(TokenizerTest ${PODOFO_DEPEND_TARGET})
-
-# Copy the test samples over to the build tree
-ADD_CUSTOM_COMMAND(
-    TARGET TokenizerTest
-    POST_BUILD
-    COMMAND "${CMAKE_COMMAND}" -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/objects" "${CMAKE_CURRENT_BINARY_DIR}/objects"
-
~~~


~~~bash
cd pododo-9.0.6
mkdir build.clang && cd build.clang
cmake .. -G Ninja -DCMAKE_INSTALL_PREFIX=c:\Users\gille\Developpement -DCMAKE_BUILD_TYPE=Release -DCMAKE_INCLUDE_PATH=c:\Users\gille\Developpement\include;c:\Users\gille\Developpement\include\freetype2 -DCMAKE_LIBRARY_PATH=c:\Users\gille\Developpement\bin
cmake --build . --config Release --target install
cd ../../bin
copyp *.dll ..\  ../chordV/chordv-code/chordv

~~~


## Compile ChordV

- in QtCreator NewProject/Import/git project https://gillesm@git.code.sf.net/p/chordv/code
